package com.logicbig.example;

import org.springframework.core.convert.support.DefaultConversionService;
import java.math.BigDecimal;

public class ConditionalGenericConverterExample {

    public static void main(String[] args) {
        DefaultConversionService service = new DefaultConversionService();
        service.addConverter(new NumberToBigDecimalConverter());

        BigDecimal bd = service.convert(Double.valueOf("2222.336"),
                BigDecimal.class);
        bd = bd.setScale(2, BigDecimal.ROUND_HALF_UP);
        System.out.println("result: " + bd);

        System.out.println("----------");
        //this will return the same BigDecimal instance without conversion
        BigDecimal bd2 = new BigDecimal("898.33");
        bd = service.convert(bd2, BigDecimal.class);
        System.out.println("result: " + bd);
        System.out.println(bd == bd2);
    }
}